import static java.lang.Math.*;

public class atomFunc{
    static vectorFunc v;
    
    public atomFunc()
    {
        v = new vectorFunc();
    }
    
    public static atom accel(atom a, vector accel, float deltaT)
    {
        atom b = new atom(a);
        b.vel = v.add(b.vel,v.scale(accel,deltaT));
        return b;
    }
    
    public static atom force(atom a, vector force, float deltaT)
    {
        return accel(a,v.scale(force,a.invmass),deltaT);
    }
    
    public static atom airdrag(atom a, float drag, float deltaT)
    {
        return force(a, v.scale(a.vel, PI * pow(a.radius,2) * -drag),deltaT);
    }
    
    public static atom stop(atom a)
    {
        atom b = new atom(a);
        b.vel = new vector(0,0);
        return b;
    }
    
    public static vector invforce(atom a)
    {
        return v.scale(a.vel,mass(a));
    }
    
    public static atom move(atom a, float deltaT)
    {
        atom b = new atom(a);
        b.pos = v.add(a.pos,v.scale(a.vel,deltaT));
        return b;
    }
    
    public static float mass(atom a)
    {
        return 1.0f/a.invmass;
    }
    
};
